/*
 * Copyright (c) 2008 IS/AIST-ST2I/CNRS
 *	Joint Japanese-French Robotics Laboratory (JRL).
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/* Authored by Anthony Mallet on Wed May  7 2008 */

#include <portLib.h>
#include <err.h>

#include "server/textosHeader.h"

#include "festival.h"
#include "EST_String.h"


/*------------------------------------------------------------------------
 *
 * ttsMainEnd  --  Termination codel
 *
 * Description: 
 * 
 * Returns:    OK or ERROR
 */

STATUS
ttsMainEnd(void)
{
  return OK;
}

/* --- Init ---------------------------------------------------------- */

/** Initialize speech synthesis system
 *
 * \returns     OK
 *              S_textos_NO_AUDIO_DEVICE
 *              S_textos_NO_MEMORY
 */

/* ttsInitMain  -  codel EXEC of Init
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
ttsInitMain(int *report)
{
  festival_initialize(1, FESTIVAL_HEAP_SIZE);
  return ETHER;
}

/* --- Say ----------------------------------------------------------- */

/** Say a string
 *
 * \returns     OK
 *		S_textos_FESTIVAL_ERROR
 */

/* ttsSayMain  -  codel EXEC of Say
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
ttsSayMain(tts_say_p *sayp, int *report)
{
  EST_String text(sayp->sentence);

  if (!festival_say_text(text))
    *report = S_textos_FESTIVAL_ERROR;
  else
    warnx(sayp->sentence);

  return ETHER;
}


